library AstonAltDesk;

uses
  Windows,
  Messages,
 // SysUtils,
  FNxxx in '..\..\FNxxx.pas',
  AstonSDK in '..\..\AstonSDK.pas',
  st_api in '..\..\st_api.pas';

//$IFDEF Debug}
// $E .plg}
//$ELSE}
{$I ..\plg.pas}
//$ENDIF}

{$IMAGEBASE $00400000}

const
  szName:Pchar = 'Aston+AltDesk 1.1';
  szCaption:Pchar = 'Aston+AltDeskWin';
 // szName:Pchar = 'AfxFrameOrView70';
 // szCaption:Pchar = 'iTouchWin';
  szHelp:PChar = 'Aston+AltDesk 1.1'#13#10+
  '      .'#13#10+
  '     AltDesk'#13#10+
  '      shift+alt+win+F1    '#13#10+
  ' shift+alt+win+F2    '#13#10+
  ' shift+alt+win+F3    '#13#10+
  ' shift+alt+win+F4    .'#13#10+
  '      12  .'#13#10+
  '     admDenis@yandex.ru'#13#10+
  ''#13#10+
  'Simple plug-in for joing AltDesk to Aston.'#13#10+
  'For correct work y0u should run AltDesk'#13#10+
  'Also y0u should setup hot-keys on virtual desktops,'#13#10+
  'shift+alt+win+F1 for the first virtual desktop.'#13#10+
  'shift+alt+win+F2 for second'#13#10+
  'and etc.'#13#10+
  'At that moment max. 12 virtualdesktops support.'#13#10+
  ''#13#10+
  'All y0ur comment  send to admDenis@yandex.ru'#13#10+
  '29.09.2004   (Konstantinov Denis)'#13#10+
  'HomePage http://admDenis.narod.ru'#13#10#13#10+
  'Special thanks to Veratil & Zealot-6';

  szAutoHide = 'AutoHide';

  szPos = 'Position';
  cPosOptions = 1;
  vPosOptions:array[0..cPosOptions] of PChar=('Left(Top)','Right(Bottom)');

  szPriority = 'Priority Position';
  szTimeToHide ='TimeToHide';

  szNumOfDeskTops = 'NumOfDeskTops';
  szSkinPath = 'SkinPath';
  szShowOnMouseOver = 'Show AltDesk OnMouseOver';

  szClickOptions = 'On Left mouse click';
  cClickOptions = 2;
  vClickOptions:array[0..cClickOptions] of PChar=('Do Nothing','Show AltDesk','Switch to hand-picked desktop');

  szDeskIco = 'Width of Desktop icon';

  szShowNum = 'Show Desktop Numbers';

  szColor = 'Numbers Color';
  szFont = 'Numbers Font';

  KeyCount = 12;
  Keys: array[1..KeyCount] of TKey = (
    (szKey:szPos; nType:KEY_LIST or KEY_NOTHEME;  szHint: szPos;
      vDefault: 0;       res1:cPosOptions; res2:0),
    (szKey:szPriority; nType:KEY_INT or KEY_NOTHEME;  szHint: szPriority;
     vDefault: 1; res1:0; res2:0),
    (szKey:szAutoHide; nType:KEY_BOOL or KEY_NOTHEME;  szHint: szAutoHide;
     vDefault: 1; res1:0; res2:0),
    (szKey:szTimeToHide; nType:KEY_INT or KEY_NOTHEME;  szHint: szTimeToHide;
     vDefault: 1000; res1:0; res2:0),
    (szKey:szNumOfDeskTops; nType:KEY_SCROLLBAR or KEY_NOTHEME;  szHint: szNumOfDeskTops;
     vDefault: 4; res1:1; res2:12),
    (szKey:szSkinPath; nType:KEY_PATH;  szHint: szSkinPath;
     vDefault: 0; res1:0; res2:0),
    (szKey:szShowOnMouseOver; nType:KEY_BOOL or KEY_NOTHEME;  szHint: szShowOnMouseOver;
     vDefault: 1; res1:0; res2:0),
    (szKey:szClickOptions; nType:KEY_LIST or KEY_NOTHEME;  szHint: szClickOptions;
      vDefault: 2;       res1:cClickOptions; res2:0),
    (szKey:szDeskIco; nType:KEY_INT or KEY_NOTHEME;  szHint: szDeskIco;
     vDefault: 20; res1:0; res2:0),
    (szKey:szShowNum; nType:KEY_BOOL or KEY_NOTHEME;  szHint: szShowNum;
     vDefault: 1; res1:0; res2:0),
    (szKey:szColor; nType:KEY_COLOR;  szHint: szColor;
     vDefault: $573f20; res1:0; res2:0),
    (szKey:szFont; nType:KEY_FONT;  szHint: szFont;
     vDefault: 1; res1:0; res2:0)
   );

var
  AData: TAstonData;
  MyAutoHide:boolean=true;
  ChildWindow:hWnd=0;
  hWndAltDesk:HWND=0;
  hMessBut:HWND=0;
  TimeToHide:integer=1000;
  MyWidth:integer = 0;
  DeskIco:integer=20;
  RecAlt,RecMy:TRect;
  Position:integer=2;
  VPriority:integer=0;
  WeWork:boolean=false;
  TimerWork:boolean=false;
  bmp_Bk,bmp_BkAlt:TPicture;
  NumOfDeskTops:integer =4;
  ShowOnMouseOver:boolean = true;
  SkinPath:string;
  ClickOptions:integer=2;
  ShowNum:boolean=true;
  Color:COLORREF;
  Font:TFont;
{----------------------------------------------------------------}
  PluginInfo:TPluginInfo;
{----------------------------------------------------------------}

function Int2Str(Number : Int64) : String;
var Minus : Boolean;
begin
{SysUtils is not in the Uses Clause so I can not use IntToStr( )
and have to define an Int2Str( ) function here}
   Result := '';
   if Number = 0 then
      Result := '0';
   Minus := Number < 0;
   if Minus then
      Number := -Number;
   while Number > 0 do
   begin
      Result := Char((Number mod 10) + Integer('0')) + Result;
      Number := Number div 10;
   end;
   if Minus then
      Result := '-' + Result;
end;



function Str2Int(S:AnsiString): Int64;
var Minus : Boolean;
    Step,N,i,j:integer;

begin
   Minus:=false;
   Result := 0;
   N:=Length(S);
for i:=1 to N do
  begin
        step:=1;
        if S[I]='-' then
        begin
                Minus:=true;
                Continue;
        end else
        if (Byte(S[I]) >47) and (Byte(S[I])<58) then
        begin
         for j:=1 to N-I do step:=step*10;
         Result :=Result+ (Byte(S[i])-48)*step;
        end;
  end;
  if Minus then Result :=Result*(-1);
end;


procedure SetKbdState(KeyCode: Byte);
 var
   KBState: TKeyboardState;
   osvi:OSVERSIONINFO;
   szVersion:array[0..80] of char;
   A_malloc:FARPROC;
   sez:Integer;
 begin

   osvi.dwOSVersionInfoSize := sizeof (OSVERSIONINFO);
   GetVersionEx (osvi);
 
   if (osvi.dwPlatformId = VER_PLATFORM_WIN32_NT) then
   begin
          keybd_event(VK_SHIFT, 1, 0, 0);
          keybd_event(VK_MENU, 1, 0, 0);
          keybd_event(VK_LWIN, 1, 0, 0);
          keybd_event(KeyCode, 1, 0, 0);
          keybd_event(KeyCode, 1, KEYEVENTF_KEYUP, 0);
          keybd_event(VK_SHIFT, 1, KEYEVENTF_KEYUP, 0);
          keybd_event(VK_MENU, 1, KEYEVENTF_KEYUP, 0);
          keybd_event(VK_LWIN, 1, KEYEVENTF_KEYUP, 0);
   end else
   begin
           GetKeyboardState(KBState);
           KBState[VK_SHIFT] := 1;
           KBState[VK_MENU] := 1;
           KBState[VK_LWIN] :=1;
           KBState[KeyCode] := 1;
           SetKeyboardState(KBState);
           KBState[VK_SHIFT] := 0;
           KBState[VK_MENU] := 0;
           KBState[VK_LWIN] :=0;
           KBState[KeyCode] := 0;
           SetKeyboardState(KBState);
   end;
 end;

function FindAltDesk():boolean;
begin
     result:=false;
     hWndAltDesk:=FindWindow('AltDesk1.x',nil);
     if hWndAltDesk>0 then result:=true;
     WeWork:=false;
     TimerWork:=false;
     KillTimer(ChildWindow,2);
end;

procedure SetPlace();
var
  wp2,wp:TRect;
  swp:WINDOWPLACEMENT;
  MyA,MyB,AltA,AltB,MyHeight,MyWidth,AltHeight,AltWidth,XSCREEN,YSCREEN:integer;
  s:string;
begin
       if(GetWindowRect(hWndAltDesk,wp)=false) then
        if(not FindAltDesk()) then exit;

        //altDesk
       GetWindowRect(ChildWindow,wp2);//MyWindow
       GetWindowPlacement(hWndAltDesk,@swp);

       //s:=' mx='+IntToStr(wp2.Left)+' my='+IntToStr(wp2.Top)+' max='+IntToStr(wp2.Right)+' may='+IntToStr(wp2.Bottom);
       //MessageBox(ChildWindow,PChar(S),'Test',MB_OK);


       MyHeight:=wp2.Bottom-wp2.Top;
       MyWidth:=wp2.Right-wp2.Left;
       MyA:=wp2.Top+(MyHeight div 2);
       MyB:=wp2.Left+(MyWidth div 2);

       AltHeight:=wp.Bottom-wp.Top;
       AltWidth:=wp.Right-wp.Left;
       AltA:=wp.Top+(AltHeight div 2);
       AltB:=wp.Left+(AltWidth div 2);

       XSCREEN:=GetSystemMetrics(SM_CXSCREEN); //1024
       YSCREEN:=GetSystemMetrics(SM_CYSCREEN); //768

       if wp2.Left<5 then // 
       begin
       //MessageBox(ChildWindow,'','Test',MB_OK);
        if (MyA>(AltHeight div 2)) and (MyA<(YSCREEN-(AltHeight div 2))) then
                begin
                //MessageBox(ChildWindow,'1','Test',MB_OK);
                swp.rcNormalPosition.Left:=wp2.Right;
                swp.rcNormalPosition.Right:=swp.rcNormalPosition.Left+AltWidth;
                swp.rcNormalPosition.Top:=MyA-(AltHeight div 2);
                swp.rcNormalPosition.Bottom:=swp.rcNormalPosition.Top+AltHeight;
                end
        else
        if (MyA<(AltHeight div 2)) then
                begin
                //MessageBox(ChildWindow,'2','Test',MB_OK);
                swp.rcNormalPosition.Left:=wp2.Right;
                swp.rcNormalPosition.Right:=swp.rcNormalPosition.Left+AltWidth;
                swp.rcNormalPosition.Top:=MyA-(AltHeight div 2)+((AltHeight div 2)-MyA);
                swp.rcNormalPosition.Bottom:=swp.rcNormalPosition.Top+AltHeight;
                end
        else
        if (MyA>(YSCREEN-(AltHeight div 2))) then
                begin
                //MessageBox(ChildWindow,'3','Test',MB_OK);
                swp.rcNormalPosition.Left:=wp2.Right;
                swp.rcNormalPosition.Right:=swp.rcNormalPosition.Left+AltWidth;
                swp.rcNormalPosition.Top:=MyA-(AltHeight div 2)-((AltHeight div 2)-(YSCREEN-MyA));
                swp.rcNormalPosition.Bottom:=swp.rcNormalPosition.Top+AltHeight;
                end;
       end
       else
       if wp2.Top=0 then  //
       begin
       //MessageBox(ChildWindow,'','Test',MB_OK);
        if (MyB>(AltWidth div 2)) and (MyB<(XSCREEN-(AltWidth div 2))) then
                begin
                //MessageBox(ChildWindow,'1','Test',MB_OK);
                swp.rcNormalPosition.Left:=MyB-(AltWidth div 2);
                swp.rcNormalPosition.Right:=swp.rcNormalPosition.Left+AltWidth;
                swp.rcNormalPosition.Top:=wp2.Bottom;
                swp.rcNormalPosition.Bottom:=swp.rcNormalPosition.Top+AltHeight;
                end
        else
        if (MyB<(AltWidth div 2)) then
                begin
                //MessageBox(ChildWindow,'2','Test',MB_OK);
                swp.rcNormalPosition.Left:=MyB-(AltWidth div 2)+((AltWidth div 2)-MyB);
                swp.rcNormalPosition.Right:=swp.rcNormalPosition.Left+AltWidth;
                swp.rcNormalPosition.Top:=wp2.Bottom;
                swp.rcNormalPosition.Bottom:=swp.rcNormalPosition.Top+AltHeight;
                end
        else
        if (MyB>(XSCREEN-(AltWidth div 2))) then
                begin
                //MessageBox(ChildWindow,'3','Test',MB_OK);
                swp.rcNormalPosition.Left:=MyB-(AltWidth div 2)-((AltWidth div 2)-(XSCREEN-MyB));
                swp.rcNormalPosition.Right:=swp.rcNormalPosition.Left+AltWidth;
                swp.rcNormalPosition.Top:=wp2.Bottom;
                swp.rcNormalPosition.Bottom:=swp.rcNormalPosition.Top+AltHeight;
                end;
       end
       else
       if (wp2.Right>(XSCREEN-5)) then  // 
       begin
       //MessageBox(ChildWindow,'','Test',MB_OK);
        if (MyA>(AltHeight div 2)) and (MyA<(YSCREEN-(AltHeight div 2))) then
                begin
                //MessageBox(ChildWindow,'1','Test',MB_OK);
                swp.rcNormalPosition.Right:=wp2.left;
                swp.rcNormalPosition.Left:=swp.rcNormalPosition.Right-AltWidth;
                swp.rcNormalPosition.Top:=MyA-(AltHeight div 2);
                swp.rcNormalPosition.Bottom:=swp.rcNormalPosition.Top+AltHeight;
                end
        else
        if (MyA<(AltHeight div 2)) then
                begin
                //MessageBox(ChildWindow,'2','Test',MB_OK);
                swp.rcNormalPosition.Right:=wp2.left;
                swp.rcNormalPosition.Left:=swp.rcNormalPosition.Right-AltWidth;
                swp.rcNormalPosition.Top:=MyA-(AltHeight div 2)+((AltHeight div 2)-MyA);
                swp.rcNormalPosition.Bottom:=swp.rcNormalPosition.Top+AltHeight;
                end
        else
        if (MyA>(YSCREEN-(AltHeight div 2))) then
                begin
                //MessageBox(ChildWindow,'3','Test',MB_OK);
                swp.rcNormalPosition.Right:=wp2.left;
                swp.rcNormalPosition.Left:=swp.rcNormalPosition.Right-AltWidth;
                swp.rcNormalPosition.Top:=MyA-(AltHeight div 2)-((AltHeight div 2)-(YSCREEN-MyA));
                swp.rcNormalPosition.Bottom:=swp.rcNormalPosition.Top+AltHeight;
                end;
       end
       else
       if wp2.Bottom=YSCREEN then //
       begin
       //MessageBox(ChildWindow,'','Test',MB_OK);
        if (MyB>(AltWidth div 2)) and (MyB<(XSCREEN-(AltWidth div 2))) then
                begin
                //MessageBox(ChildWindow,'1','Test',MB_OK);
                swp.rcNormalPosition.Left:=MyB-(AltWidth div 2);
                swp.rcNormalPosition.Right:=swp.rcNormalPosition.Left+AltWidth;
                swp.rcNormalPosition.Bottom:=wp2.Top;
                swp.rcNormalPosition.Top:=swp.rcNormalPosition.Bottom-AltHeight;
                end
        else
        if (MyB<(AltWidth div 2)) then
                begin
                //MessageBox(ChildWindow,'2','Test',MB_OK);
                swp.rcNormalPosition.Left:=MyB-(AltWidth div 2)+((AltWidth div 2)-MyB);
                swp.rcNormalPosition.Right:=swp.rcNormalPosition.Left+AltWidth;
                swp.rcNormalPosition.Bottom:=wp2.Top;
                swp.rcNormalPosition.Top:=swp.rcNormalPosition.Bottom-AltHeight;
                end
        else
        if (MyB>(XSCREEN-(AltWidth div 2))) then
                begin
                //MessageBox(ChildWindow,'3','Test',MB_OK);
                swp.rcNormalPosition.Left:=MyB-(AltWidth div 2)-((AltWidth div 2)-(XSCREEN-MyB));
                swp.rcNormalPosition.Right:=swp.rcNormalPosition.Left+AltWidth;
                swp.rcNormalPosition.Bottom:=wp2.Top;
                swp.rcNormalPosition.Top:=swp.rcNormalPosition.Bottom-AltHeight;
                end;
       end;

       swp.rcNormalPosition.TopLeft.X:=swp.rcNormalPosition.Left;
       swp.rcNormalPosition.TopLeft.Y:=swp.rcNormalPosition.Top;
       swp.rcNormalPosition.BottomRight.X:=swp.rcNormalPosition.Right;
       swp.rcNormalPosition.BottomRight.Y:=swp.rcNormalPosition.Bottom;

       if (swp.rcNormalPosition.Right>swp.rcNormalPosition.Left) and
          (swp.rcNormalPosition.Bottom>swp.rcNormalPosition.Top) and
          (swp.rcNormalPosition.Right>=0)and(swp.rcNormalPosition.Right<=XSCREEN)and
          (swp.rcNormalPosition.Left>=0)and(swp.rcNormalPosition.Left<=XSCREEN)and
          (swp.rcNormalPosition.Top>=0)and(swp.rcNormalPosition.Top<=YSCREEN)and
          (swp.rcNormalPosition.Bottom>=0)and(swp.rcNormalPosition.Bottom<=YSCREEN)
       then   SetWindowPlacement(hWndAltDesk,@swp);
//       else
       //s:='left='+IntToStr(swp.rcNormalPosition.Left)+' top='+IntToStr(swp.rcNormalPosition.Top)+' right='+IntToStr(swp.rcNormalPosition.Right)+' bottom='+IntToStr(swp.rcNormalPosition.Bottom)+' tlx='+IntToStr(swp.rcNormalPosition.TopLeft.X)+' tlY='+IntToStr(swp.rcNormalPosition.TopLeft.Y)+' brx='+IntToStr(swp.rcNormalPosition.BottomRight.X)+' bry='+IntToStr(swp.rcNormalPosition.BottomRight.Y);
       //MessageBox(ChildWindow,PChar(S),'Test',MB_OK);
end;



function WindowProc(Window: HWnd; Message:UINT; WParam: WParam;
  LParam: LParam): Longint;  stdcall;
var
  DC: hDC;
  ps: TPaintStruct;
  wp:TRect;
  r,r1:TRect;
  p:TPoint;
  uFlags:UINT;
  CurHWND:HWND;
  xPos,yPos:integer;
  KeyState:  TKeyboardState;
  Old:HGDIOBJ;
  OldMode:integer;
  buf:array[0..MAX_PATH+1]of char;
  i,bufcount:integer;
  FakeWnd:string;
  s:string;
  TP:TPMPARAMS ;
  Menu:HMENU;
begin
  result := 0;
  case Message of
    WM_PAINT:
    begin
      DC:=BeginPaint(ChildWindow, ps);
      {Draw skin}
      GetClientRect(ChildWindow, r);

      uFlags := 0;
      uFlags := uFlags or DPEx_TILED;
//      uFlags:= uFlags or DPEx_CENTERED;
{
      if (r.right<>bmp_BkAlt.Width)or(r.bottom<>bmp_BkAlt.Height)
        then  StretchSkin(AData.MemoryDC,bmp_BkAlt, @bmp_Bk, r.right, r.bottom);
 }
      SelectObject(dc, bmp_BkAlt.Handle);
      DrawSkin(dc,dc, r, r, r, @bmp_BkAlt,AData.WallPaperInfo.DesktopBrush, uFlags);

      if ShowNum then
      begin
      Old := SelectObject(dc, Font.Handle);
      OldMode := SetBkMode(dc, TRANSPARENT);
      SetTextColor(dc, Color);

      for i:=0 to NumOfDeskTops-1 do
      begin
        SetRect(r1, DeskIco*i, 0, DeskIco*i+DeskIco, 24);
        DrawText(dc, PChar(Int2Str(i+1)), -1, r1, DT_VCENTER or DT_CENTER or DT_SINGLELINE or DT_NOCLIP or DT_NOPREFIX);
      end;
      
      SelectObject(dc, Old);
      SetBkMode(dc, OldMode);
      end;

      {End Draw Skin}
      EndPaint(ChildWindow, ps);
      exit;
    end;
    WM_MOUSEMOVE:
    begin
    SetTimer(ChildWindow,1,100,@WindowProc);
    if ShowOnMouseOver then
    BEGIN
     if not WeWork then
      begin
       GetWindowRect(hWndAltDesk,wp);//altDesk
       if (wp.TopLeft.X<>RecAlt.TopLeft.X)or(wp.TopLeft.Y<>RecAlt.TopLeft.Y)or(wp.BottomRight.X<>RecAlt.BottomRight.X)or(wp.BottomRight.Y<>RecAlt.BottomRight.Y) then SetPlace();
       RecAlt:=wp;
       GetWindowRect(ChildWindow,wp);//MyWindow
       if (wp.TopLeft.X<>RecMy.TopLeft.X)or(wp.TopLeft.Y<>RecMy.TopLeft.Y)or(wp.BottomRight.X<>RecMy.BottomRight.X)or(wp.BottomRight.Y<>RecMy.BottomRight.Y) then SetPlace();
       RecMy:=wp;

       WeWork:=true;
       TimerWork:=false;
       SendMessage(hWndAltDesk,WM_SYSCOMMAND,SC_RESTORE,0);
       end;
       END;//if ShowOnMouseOver
    end;
    WM_TIMER:
    begin

    if (GetWindowRect(hWndAltDesk,wp)=false)then //altDesk
     FindAltDesk();

    if (wp.TopLeft.X<>RecAlt.TopLeft.X)or(wp.TopLeft.Y<>RecAlt.TopLeft.Y)or(wp.BottomRight.X<>RecAlt.BottomRight.X)or(wp.BottomRight.Y<>RecAlt.BottomRight.Y) then SetPlace();
    RecAlt:=wp;
    GetWindowRect(ChildWindow,wp);//MyWindow
    if (wp.TopLeft.X<>RecMy.TopLeft.X)or(wp.TopLeft.Y<>RecMy.TopLeft.Y)or(wp.BottomRight.X<>RecMy.BottomRight.X)or(wp.BottomRight.Y<>RecMy.BottomRight.Y) then SetPlace();
    RecMy:=wp;

    if WParam=2 then
    begin
        KillTimer(ChildWindow,1);
        KillTimer(ChildWindow,2);
        WeWork:=false;
        TimerWork:=false;
       SendMessage(hWndAltDesk,WM_SHOWWINDOW,0,SW_SHOWNORMAL);
    end;
    if WParam=1 then
      begin
      GetCursorPos(P);
      CurHWND:=WindowFromPoint(P);
      bufcount:=GetClassName(CurHWND,@buf,MAX_PATH);
      FakeWnd:='';
      if bufcount>0 then
      for i:=0 to bufcount-1 do FakeWnd:=FakeWnd+buf[i];
      if ((CurHWND=ChildWindow) or (CurHWND=hWndAltDesk) or (FakeWnd='FakeWnd'))and(CurHWND<>0) then
              begin
              KillTimer(ChildWindow,2);
              TimerWork:=false;
              WeWork:=true;
              end else
              begin
              if MyAutoHide then
              begin
              if not TimerWork then
               begin
                 SetTimer(ChildWindow,2,TimeToHide,@WindowProc);
                 TimerWork:=true;
               end;
               end
               else KillTimer(ChildWindow,1);
              end;

      end;
    end;
    WM_LBUTTONDOWN:
    begin
    case ClickOptions of
    0:begin end;

    1: // show altdesk
    begin
    SendMessage(hWndAltDesk,WM_SYSCOMMAND,SC_RESTORE,0);
    end;//1

    2:  // switch to desk top
    begin
    xPos:= LOWORD(lParam);  // horizontal position of cursor
    yPos:= HIWORD(lParam);
            for i:=0 to NumOfDeskTops-1 do
                begin
                if (  (xPos>=DeskIco*i) and (xPos<DeskIco*i+DeskIco)) then SetKbdState(112+i);
                end;
    end;//2
    end;// case
    end;
    WM_CONTEXTMENU:
    begin
        GetWindowRect(AData.Taskbar, TP.rcExclude);
        TP.cbSize:= sizeof(TPMPARAMS);
        SetFocus(window);
        Menu:= CreatePopupMenu();
        AppendMenu(Menu, MF_STRING, 500, 'About');
        AppendMenu(Menu, MF_SEPARATOR, 0, NiL);
        AppendMenu(Menu, MF_STRING, 502, '&Show AltDesk');
        AppendMenu(Menu, MF_STRING, 501, '&Properties');
        TrackPopupMenuEx(Menu, TPM_RIGHTBUTTON, LOWORD(lParam),
        HIWORD(lParam),ChildWindow, @TP);
        DestroyMenu(Menu);
    end;//WM_CONTEXTMENU
    WM_RBUTTONUP:
    begin
    //SetKbdState(VK_F1);
    end;
    WM_COMMAND:
    begin
    case LOWORD(wParam) of
        500:
        begin
           MessageBox(ChildWindow,szHelp,'About Aston+AltDesk',MB_OK);
//        MessageBox(ChildWindow,AData.Node.WorkDir,'About Aston+AltDesk',MB_OK);
        end;
        501:
        begin
            buf[0]:= '/';
            lstrcpy(@buf[1], AData.Node.Path);
            SendMessage(AData.MainWindow, CM_SETUPASTON, 0, longint(@Buf[0]) );
        end;
        502:
        begin
             SendMessage(hWndAltDesk,WM_SYSCOMMAND,SC_RESTORE,0);
        end;
    end;//case
    end;//WM_COMMAND
 {   WM_USER+26:
    BEGIN
     s:='WP='+IntToStr(wParam)+' LP='+IntToStr(lParam);
     MessageBox(ChildWindow,PChar(s),'Test',MB_OK);
    END;}
  end;//case

  result := DefWindowProc(Window, Message, WParam, LParam);
end;

{----------------------------------------------------------------}
procedure ReadConfig;
var
 CFG:TCFG;
 DockInfo: TDockInfo;
 logon: boolean;
 s:string;
 A_malloc:FARPROC;
 i:integer;
 tmp:array[0..MAX_PATH+1] of CHAR;
begin
 OpenCFGr(AData.PluginsCFG, @CFG);
 FindSection(@szName[0], 0, @CFG);

 Position:= GetCFGInt(szPos, 0, @CFG);
 CheckInt(Position, 0, cPosOptions, 0);

 ClickOptions:=GetCFGInt(szClickOptions, 2, @CFG);
 CheckInt(ClickOptions, 0, cClickOptions, 0);

 TimeToHide:=GetCFGInt(szTimeToHide, 1000, @CFG);
 CheckInt(TimeToHide, 0, 100000, 0);

 VPriority:=GetCFGInt(szPriority, 0, @CFG);
 CheckInt(VPriority, 0, 100000, 0);

 MyAutoHide:=GetCFGBool(szAutoHide,true,@CFG);

 NumOfDeskTops:=GetCFGInt(szNumOfDeskTops, 4, @CFG);

 ShowOnMouseOver:=GetCFGBool(szShowOnMouseOver,true,@CFG);

 DeskIco:=GetCFGInt(szDeskIco, 20, @CFG);

 ShowNum:= GetCFGBool(szShowNum,true,@CFG);

 GetCFGString(szSkinPath,'Plugins\Aston+AltDesk.bmp',tmp,max_path,@CFG);

 Color := GetCFGHex(szColor, $dad0ad, @CFG);
 GetCFGFont(szFont, @Font, @CFG);
 GetFontHandle(@Font, GetStockObject(ANSI_VAR_FONT));

 MyWidth:=0;
 for i:=1 to NumOfDeskTops do MyWidth:=MyWidth+DeskIco;

 CloseCFGr(@CFG);
 //inc(Position);
//  s:='NumOfDeskTops='+IntToStr(NumOfDeskTops);
// MessageBox(ChildWindow,PChar(s),'Test',MB_OK);

 with DockInfo do
  begin
    Wnd:=ChildWindow;
    Parent:= AData.Taskbar;
    SetRect(rc_Client, 0,0,MyWidth, AData.Ring1.ButtonHeight);
    Align:= Position;
    Vert:=false;
    Flat:=false;
    Priority:=VPriority;
  end;
  SendMessage(AData.MainWindow, CM_DOCK, 0, longint(@DockInfo));
  
  RtlZeroMemory(@bmp_Bk, sizeof(bmp_Bk));
  bmp_Bk.Options := BMP_NOMASK;
 { A_malloc := GetProcAddress(GetModuleHandle(APIdll), 'malloc');
    asm
      mov EAX, MAX_PATH
      call A_malloc
      mov bmp_Bk.FileName, EAX
    end;
  lstrcpy(bmp_Bk.FileName,'d:\work\borland\aston\Examples\TaskbarWnd\tray.bmp');
  }
 bmp_Bk.FileName:=@tmp[0];
  LoadImageEx(@bmp_Bk);



  RtlMoveMemory(@bmp_BkAlt, @bmp_Bk, sizeof(bmp_BkAlt));
  bmp_BkAlt.FileName := NiL;
  bmp_BkAlt.Shared := TRUE;
  
// s:='w='+IntToStr(bmp_BkAlt.Width)+'  h='+IntToStr(bmp_BkAlt.height);
// MessageBox(ChildWindow,PChar(s),'Test',MB_OK);

end;

{----------------------------------------------------------------}

procedure InitGlobalModule(const AstonData:PAstonData);stdcall;
var
  WindowClass:TWndClass;
  DockInfo: TDockInfo;
  dc:hdc;
begin
  FindAltDesk();

  RtlMoveMemory(@AData, AstonData, SizeOf(TAstonData));

  RtlZeroMemory(@WindowClass, sizeOf(TWndClass));
  WindowClass.style:=CS_HREDRAW or CS_VREDRAW;
  WindowClass.hCursor := LoadCursor(0, IDC_ARROW);
  WindowClass.hbrBackground:=COLOR_BTNFACE+1;
  WindowClass.hInstance := HInstance;
  WindowClass.lpfnWndProc:=@WindowProc;
  WindowClass.lpszClassName:= szName;
  if RegisterClass(WindowClass) = 0 then exit;


  ReadConfig;

  ChildWindow:= CreateWindowEx(0,
    szName,
    szCaption,
    WS_VISIBLE or WS_CHILD or WS_CLIPSIBLINGS or WS_CLIPCHILDREN,
    0, 0,
    0, 0,
    AData.TaskBar,{AData.Desktop,}
    0,
    hInstance,
    nil);

  AData.Node.Wnd:= ChildWindow;
  AData.Node.NodeType:=AData.Node.NodeType or NODE_WM_TIMECHANGE_REGISTER;
  AData.Node.Hint:='Fuck!';
  with DockInfo do
  begin
    Wnd:=ChildWindow;
    Parent:= AData.Taskbar;
    SetRect(rc_Client, 0,0, MyWidth, AData.Ring1.ButtonHeight);
    Align:= Position;
    Vert:=true;
    Flat:=true;
    Priority:=VPriority;
  end;
  SendMessage(AData.MainWindow, CM_DOCK, 0, longint(@DockInfo));

  //AData.WallPaperInfo.WallPaper.FileName:='D:\wincmd\program file\Aston\Plugins\Aston+AltDesk.bmp';
  //AData.WallPaperInfo.WallPaper.DefFileName:='D:\wincmd\program file\Aston\Plugins\Aston+AltDesk.bmp';

 { hMessBut := CreateWindow('Button','#1',
    WS_VISIBLE or WS_CHILD or BS_PUSHBUTTON or BS_TEXT,
    0,0,24,24,ChildWindow,0,hInstance,nil);
  }
end;

function GetPluginInfo:PPluginInfo;stdcall;
begin
 PluginInfo.cbSize:= SizeOf(TPluginInfo);
 PluginInfo.szName:=szName;
 PluginInfo.szDescription:=szHelp;
 PluginInfo.szSection:=szName;
 PluginInfo.nKeyCount:=KeyCount;
 PluginInfo.Keys:=@Keys;
// Keys[1].res2:=integer(@vSchedule);
 Keys[1].res2:=integer(@vPosOptions);
 Keys[8].res2:=integer(@vClickOptions);
 result:= @PluginInfo;
end;

{----------------------------------------------------------------}

procedure DoneModule; stdcall;
begin
  if ChildWindow<>0 then
  begin
    FreePicture(@bmp_Bk);
    RtlZeroMemory(@bmp_Bk, sizeof(bmp_Bk));
    FreePicture(@bmp_BkAlt);
    RtlZeroMemory(@bmp_BkAlt, sizeof(bmp_BkAlt));
    FreeFont(@Font);
    DestroyWindow(ChildWindow);
    ChildWindow:=0;
  end;
  UnregisterClass(szName, hInstance);
end;

{----------------------------------------------------------------}

exports
  InitGlobalModule,
  DoneModule,
  GetPluginInfo;
end.
